import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { CreateCapacityProviderCommandInput, CreateCapacityProviderCommandOutput } from "../commands/CreateCapacityProviderCommand";
import { CreateClusterCommandInput, CreateClusterCommandOutput } from "../commands/CreateClusterCommand";
import { CreateServiceCommandInput, CreateServiceCommandOutput } from "../commands/CreateServiceCommand";
import { CreateTaskSetCommandInput, CreateTaskSetCommandOutput } from "../commands/CreateTaskSetCommand";
import { DeleteAccountSettingCommandInput, DeleteAccountSettingCommandOutput } from "../commands/DeleteAccountSettingCommand";
import { DeleteAttributesCommandInput, DeleteAttributesCommandOutput } from "../commands/DeleteAttributesCommand";
import { DeleteCapacityProviderCommandInput, DeleteCapacityProviderCommandOutput } from "../commands/DeleteCapacityProviderCommand";
import { DeleteClusterCommandInput, DeleteClusterCommandOutput } from "../commands/DeleteClusterCommand";
import { DeleteServiceCommandInput, DeleteServiceCommandOutput } from "../commands/DeleteServiceCommand";
import { DeleteTaskDefinitionsCommandInput, DeleteTaskDefinitionsCommandOutput } from "../commands/DeleteTaskDefinitionsCommand";
import { DeleteTaskSetCommandInput, DeleteTaskSetCommandOutput } from "../commands/DeleteTaskSetCommand";
import { DeregisterContainerInstanceCommandInput, DeregisterContainerInstanceCommandOutput } from "../commands/DeregisterContainerInstanceCommand";
import { DeregisterTaskDefinitionCommandInput, DeregisterTaskDefinitionCommandOutput } from "../commands/DeregisterTaskDefinitionCommand";
import { DescribeCapacityProvidersCommandInput, DescribeCapacityProvidersCommandOutput } from "../commands/DescribeCapacityProvidersCommand";
import { DescribeClustersCommandInput, DescribeClustersCommandOutput } from "../commands/DescribeClustersCommand";
import { DescribeContainerInstancesCommandInput, DescribeContainerInstancesCommandOutput } from "../commands/DescribeContainerInstancesCommand";
import { DescribeServicesCommandInput, DescribeServicesCommandOutput } from "../commands/DescribeServicesCommand";
import { DescribeTaskDefinitionCommandInput, DescribeTaskDefinitionCommandOutput } from "../commands/DescribeTaskDefinitionCommand";
import { DescribeTasksCommandInput, DescribeTasksCommandOutput } from "../commands/DescribeTasksCommand";
import { DescribeTaskSetsCommandInput, DescribeTaskSetsCommandOutput } from "../commands/DescribeTaskSetsCommand";
import { DiscoverPollEndpointCommandInput, DiscoverPollEndpointCommandOutput } from "../commands/DiscoverPollEndpointCommand";
import { ExecuteCommandCommandInput, ExecuteCommandCommandOutput } from "../commands/ExecuteCommandCommand";
import { GetTaskProtectionCommandInput, GetTaskProtectionCommandOutput } from "../commands/GetTaskProtectionCommand";
import { ListAccountSettingsCommandInput, ListAccountSettingsCommandOutput } from "../commands/ListAccountSettingsCommand";
import { ListAttributesCommandInput, ListAttributesCommandOutput } from "../commands/ListAttributesCommand";
import { ListClustersCommandInput, ListClustersCommandOutput } from "../commands/ListClustersCommand";
import { ListContainerInstancesCommandInput, ListContainerInstancesCommandOutput } from "../commands/ListContainerInstancesCommand";
import { ListServicesByNamespaceCommandInput, ListServicesByNamespaceCommandOutput } from "../commands/ListServicesByNamespaceCommand";
import { ListServicesCommandInput, ListServicesCommandOutput } from "../commands/ListServicesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { ListTaskDefinitionFamiliesCommandInput, ListTaskDefinitionFamiliesCommandOutput } from "../commands/ListTaskDefinitionFamiliesCommand";
import { ListTaskDefinitionsCommandInput, ListTaskDefinitionsCommandOutput } from "../commands/ListTaskDefinitionsCommand";
import { ListTasksCommandInput, ListTasksCommandOutput } from "../commands/ListTasksCommand";
import { PutAccountSettingCommandInput, PutAccountSettingCommandOutput } from "../commands/PutAccountSettingCommand";
import { PutAccountSettingDefaultCommandInput, PutAccountSettingDefaultCommandOutput } from "../commands/PutAccountSettingDefaultCommand";
import { PutAttributesCommandInput, PutAttributesCommandOutput } from "../commands/PutAttributesCommand";
import { PutClusterCapacityProvidersCommandInput, PutClusterCapacityProvidersCommandOutput } from "../commands/PutClusterCapacityProvidersCommand";
import { RegisterContainerInstanceCommandInput, RegisterContainerInstanceCommandOutput } from "../commands/RegisterContainerInstanceCommand";
import { RegisterTaskDefinitionCommandInput, RegisterTaskDefinitionCommandOutput } from "../commands/RegisterTaskDefinitionCommand";
import { RunTaskCommandInput, RunTaskCommandOutput } from "../commands/RunTaskCommand";
import { StartTaskCommandInput, StartTaskCommandOutput } from "../commands/StartTaskCommand";
import { StopTaskCommandInput, StopTaskCommandOutput } from "../commands/StopTaskCommand";
import { SubmitAttachmentStateChangesCommandInput, SubmitAttachmentStateChangesCommandOutput } from "../commands/SubmitAttachmentStateChangesCommand";
import { SubmitContainerStateChangeCommandInput, SubmitContainerStateChangeCommandOutput } from "../commands/SubmitContainerStateChangeCommand";
import { SubmitTaskStateChangeCommandInput, SubmitTaskStateChangeCommandOutput } from "../commands/SubmitTaskStateChangeCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateCapacityProviderCommandInput, UpdateCapacityProviderCommandOutput } from "../commands/UpdateCapacityProviderCommand";
import { UpdateClusterCommandInput, UpdateClusterCommandOutput } from "../commands/UpdateClusterCommand";
import { UpdateClusterSettingsCommandInput, UpdateClusterSettingsCommandOutput } from "../commands/UpdateClusterSettingsCommand";
import { UpdateContainerAgentCommandInput, UpdateContainerAgentCommandOutput } from "../commands/UpdateContainerAgentCommand";
import { UpdateContainerInstancesStateCommandInput, UpdateContainerInstancesStateCommandOutput } from "../commands/UpdateContainerInstancesStateCommand";
import { UpdateServiceCommandInput, UpdateServiceCommandOutput } from "../commands/UpdateServiceCommand";
import { UpdateServicePrimaryTaskSetCommandInput, UpdateServicePrimaryTaskSetCommandOutput } from "../commands/UpdateServicePrimaryTaskSetCommand";
import { UpdateTaskProtectionCommandInput, UpdateTaskProtectionCommandOutput } from "../commands/UpdateTaskProtectionCommand";
import { UpdateTaskSetCommandInput, UpdateTaskSetCommandOutput } from "../commands/UpdateTaskSetCommand";
/**
 * serializeAws_json1_1CreateCapacityProviderCommand
 */
export declare const se_CreateCapacityProviderCommand: (input: CreateCapacityProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateClusterCommand
 */
export declare const se_CreateClusterCommand: (input: CreateClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateServiceCommand
 */
export declare const se_CreateServiceCommand: (input: CreateServiceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateTaskSetCommand
 */
export declare const se_CreateTaskSetCommand: (input: CreateTaskSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteAccountSettingCommand
 */
export declare const se_DeleteAccountSettingCommand: (input: DeleteAccountSettingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteAttributesCommand
 */
export declare const se_DeleteAttributesCommand: (input: DeleteAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteCapacityProviderCommand
 */
export declare const se_DeleteCapacityProviderCommand: (input: DeleteCapacityProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteClusterCommand
 */
export declare const se_DeleteClusterCommand: (input: DeleteClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteServiceCommand
 */
export declare const se_DeleteServiceCommand: (input: DeleteServiceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteTaskDefinitionsCommand
 */
export declare const se_DeleteTaskDefinitionsCommand: (input: DeleteTaskDefinitionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteTaskSetCommand
 */
export declare const se_DeleteTaskSetCommand: (input: DeleteTaskSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeregisterContainerInstanceCommand
 */
export declare const se_DeregisterContainerInstanceCommand: (input: DeregisterContainerInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeregisterTaskDefinitionCommand
 */
export declare const se_DeregisterTaskDefinitionCommand: (input: DeregisterTaskDefinitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeCapacityProvidersCommand
 */
export declare const se_DescribeCapacityProvidersCommand: (input: DescribeCapacityProvidersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeClustersCommand
 */
export declare const se_DescribeClustersCommand: (input: DescribeClustersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeContainerInstancesCommand
 */
export declare const se_DescribeContainerInstancesCommand: (input: DescribeContainerInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeServicesCommand
 */
export declare const se_DescribeServicesCommand: (input: DescribeServicesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeTaskDefinitionCommand
 */
export declare const se_DescribeTaskDefinitionCommand: (input: DescribeTaskDefinitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeTasksCommand
 */
export declare const se_DescribeTasksCommand: (input: DescribeTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeTaskSetsCommand
 */
export declare const se_DescribeTaskSetsCommand: (input: DescribeTaskSetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DiscoverPollEndpointCommand
 */
export declare const se_DiscoverPollEndpointCommand: (input: DiscoverPollEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ExecuteCommandCommand
 */
export declare const se_ExecuteCommandCommand: (input: ExecuteCommandCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetTaskProtectionCommand
 */
export declare const se_GetTaskProtectionCommand: (input: GetTaskProtectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAccountSettingsCommand
 */
export declare const se_ListAccountSettingsCommand: (input: ListAccountSettingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAttributesCommand
 */
export declare const se_ListAttributesCommand: (input: ListAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListClustersCommand
 */
export declare const se_ListClustersCommand: (input: ListClustersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListContainerInstancesCommand
 */
export declare const se_ListContainerInstancesCommand: (input: ListContainerInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListServicesCommand
 */
export declare const se_ListServicesCommand: (input: ListServicesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListServicesByNamespaceCommand
 */
export declare const se_ListServicesByNamespaceCommand: (input: ListServicesByNamespaceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTaskDefinitionFamiliesCommand
 */
export declare const se_ListTaskDefinitionFamiliesCommand: (input: ListTaskDefinitionFamiliesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTaskDefinitionsCommand
 */
export declare const se_ListTaskDefinitionsCommand: (input: ListTaskDefinitionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTasksCommand
 */
export declare const se_ListTasksCommand: (input: ListTasksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutAccountSettingCommand
 */
export declare const se_PutAccountSettingCommand: (input: PutAccountSettingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutAccountSettingDefaultCommand
 */
export declare const se_PutAccountSettingDefaultCommand: (input: PutAccountSettingDefaultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutAttributesCommand
 */
export declare const se_PutAttributesCommand: (input: PutAttributesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutClusterCapacityProvidersCommand
 */
export declare const se_PutClusterCapacityProvidersCommand: (input: PutClusterCapacityProvidersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RegisterContainerInstanceCommand
 */
export declare const se_RegisterContainerInstanceCommand: (input: RegisterContainerInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RegisterTaskDefinitionCommand
 */
export declare const se_RegisterTaskDefinitionCommand: (input: RegisterTaskDefinitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RunTaskCommand
 */
export declare const se_RunTaskCommand: (input: RunTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartTaskCommand
 */
export declare const se_StartTaskCommand: (input: StartTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StopTaskCommand
 */
export declare const se_StopTaskCommand: (input: StopTaskCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SubmitAttachmentStateChangesCommand
 */
export declare const se_SubmitAttachmentStateChangesCommand: (input: SubmitAttachmentStateChangesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SubmitContainerStateChangeCommand
 */
export declare const se_SubmitContainerStateChangeCommand: (input: SubmitContainerStateChangeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SubmitTaskStateChangeCommand
 */
export declare const se_SubmitTaskStateChangeCommand: (input: SubmitTaskStateChangeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateCapacityProviderCommand
 */
export declare const se_UpdateCapacityProviderCommand: (input: UpdateCapacityProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateClusterCommand
 */
export declare const se_UpdateClusterCommand: (input: UpdateClusterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateClusterSettingsCommand
 */
export declare const se_UpdateClusterSettingsCommand: (input: UpdateClusterSettingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateContainerAgentCommand
 */
export declare const se_UpdateContainerAgentCommand: (input: UpdateContainerAgentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateContainerInstancesStateCommand
 */
export declare const se_UpdateContainerInstancesStateCommand: (input: UpdateContainerInstancesStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateServiceCommand
 */
export declare const se_UpdateServiceCommand: (input: UpdateServiceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateServicePrimaryTaskSetCommand
 */
export declare const se_UpdateServicePrimaryTaskSetCommand: (input: UpdateServicePrimaryTaskSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateTaskProtectionCommand
 */
export declare const se_UpdateTaskProtectionCommand: (input: UpdateTaskProtectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateTaskSetCommand
 */
export declare const se_UpdateTaskSetCommand: (input: UpdateTaskSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1CreateCapacityProviderCommand
 */
export declare const de_CreateCapacityProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCapacityProviderCommandOutput>;
/**
 * deserializeAws_json1_1CreateClusterCommand
 */
export declare const de_CreateClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateClusterCommandOutput>;
/**
 * deserializeAws_json1_1CreateServiceCommand
 */
export declare const de_CreateServiceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateServiceCommandOutput>;
/**
 * deserializeAws_json1_1CreateTaskSetCommand
 */
export declare const de_CreateTaskSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTaskSetCommandOutput>;
/**
 * deserializeAws_json1_1DeleteAccountSettingCommand
 */
export declare const de_DeleteAccountSettingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAccountSettingCommandOutput>;
/**
 * deserializeAws_json1_1DeleteAttributesCommand
 */
export declare const de_DeleteAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAttributesCommandOutput>;
/**
 * deserializeAws_json1_1DeleteCapacityProviderCommand
 */
export declare const de_DeleteCapacityProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCapacityProviderCommandOutput>;
/**
 * deserializeAws_json1_1DeleteClusterCommand
 */
export declare const de_DeleteClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteClusterCommandOutput>;
/**
 * deserializeAws_json1_1DeleteServiceCommand
 */
export declare const de_DeleteServiceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteServiceCommandOutput>;
/**
 * deserializeAws_json1_1DeleteTaskDefinitionsCommand
 */
export declare const de_DeleteTaskDefinitionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTaskDefinitionsCommandOutput>;
/**
 * deserializeAws_json1_1DeleteTaskSetCommand
 */
export declare const de_DeleteTaskSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTaskSetCommandOutput>;
/**
 * deserializeAws_json1_1DeregisterContainerInstanceCommand
 */
export declare const de_DeregisterContainerInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterContainerInstanceCommandOutput>;
/**
 * deserializeAws_json1_1DeregisterTaskDefinitionCommand
 */
export declare const de_DeregisterTaskDefinitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterTaskDefinitionCommandOutput>;
/**
 * deserializeAws_json1_1DescribeCapacityProvidersCommand
 */
export declare const de_DescribeCapacityProvidersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCapacityProvidersCommandOutput>;
/**
 * deserializeAws_json1_1DescribeClustersCommand
 */
export declare const de_DescribeClustersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeClustersCommandOutput>;
/**
 * deserializeAws_json1_1DescribeContainerInstancesCommand
 */
export declare const de_DescribeContainerInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeContainerInstancesCommandOutput>;
/**
 * deserializeAws_json1_1DescribeServicesCommand
 */
export declare const de_DescribeServicesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeServicesCommandOutput>;
/**
 * deserializeAws_json1_1DescribeTaskDefinitionCommand
 */
export declare const de_DescribeTaskDefinitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTaskDefinitionCommandOutput>;
/**
 * deserializeAws_json1_1DescribeTasksCommand
 */
export declare const de_DescribeTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTasksCommandOutput>;
/**
 * deserializeAws_json1_1DescribeTaskSetsCommand
 */
export declare const de_DescribeTaskSetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTaskSetsCommandOutput>;
/**
 * deserializeAws_json1_1DiscoverPollEndpointCommand
 */
export declare const de_DiscoverPollEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DiscoverPollEndpointCommandOutput>;
/**
 * deserializeAws_json1_1ExecuteCommandCommand
 */
export declare const de_ExecuteCommandCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExecuteCommandCommandOutput>;
/**
 * deserializeAws_json1_1GetTaskProtectionCommand
 */
export declare const de_GetTaskProtectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTaskProtectionCommandOutput>;
/**
 * deserializeAws_json1_1ListAccountSettingsCommand
 */
export declare const de_ListAccountSettingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAccountSettingsCommandOutput>;
/**
 * deserializeAws_json1_1ListAttributesCommand
 */
export declare const de_ListAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAttributesCommandOutput>;
/**
 * deserializeAws_json1_1ListClustersCommand
 */
export declare const de_ListClustersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListClustersCommandOutput>;
/**
 * deserializeAws_json1_1ListContainerInstancesCommand
 */
export declare const de_ListContainerInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListContainerInstancesCommandOutput>;
/**
 * deserializeAws_json1_1ListServicesCommand
 */
export declare const de_ListServicesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListServicesCommandOutput>;
/**
 * deserializeAws_json1_1ListServicesByNamespaceCommand
 */
export declare const de_ListServicesByNamespaceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListServicesByNamespaceCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1ListTaskDefinitionFamiliesCommand
 */
export declare const de_ListTaskDefinitionFamiliesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTaskDefinitionFamiliesCommandOutput>;
/**
 * deserializeAws_json1_1ListTaskDefinitionsCommand
 */
export declare const de_ListTaskDefinitionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTaskDefinitionsCommandOutput>;
/**
 * deserializeAws_json1_1ListTasksCommand
 */
export declare const de_ListTasksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTasksCommandOutput>;
/**
 * deserializeAws_json1_1PutAccountSettingCommand
 */
export declare const de_PutAccountSettingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutAccountSettingCommandOutput>;
/**
 * deserializeAws_json1_1PutAccountSettingDefaultCommand
 */
export declare const de_PutAccountSettingDefaultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutAccountSettingDefaultCommandOutput>;
/**
 * deserializeAws_json1_1PutAttributesCommand
 */
export declare const de_PutAttributesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutAttributesCommandOutput>;
/**
 * deserializeAws_json1_1PutClusterCapacityProvidersCommand
 */
export declare const de_PutClusterCapacityProvidersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutClusterCapacityProvidersCommandOutput>;
/**
 * deserializeAws_json1_1RegisterContainerInstanceCommand
 */
export declare const de_RegisterContainerInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterContainerInstanceCommandOutput>;
/**
 * deserializeAws_json1_1RegisterTaskDefinitionCommand
 */
export declare const de_RegisterTaskDefinitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterTaskDefinitionCommandOutput>;
/**
 * deserializeAws_json1_1RunTaskCommand
 */
export declare const de_RunTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RunTaskCommandOutput>;
/**
 * deserializeAws_json1_1StartTaskCommand
 */
export declare const de_StartTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartTaskCommandOutput>;
/**
 * deserializeAws_json1_1StopTaskCommand
 */
export declare const de_StopTaskCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopTaskCommandOutput>;
/**
 * deserializeAws_json1_1SubmitAttachmentStateChangesCommand
 */
export declare const de_SubmitAttachmentStateChangesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SubmitAttachmentStateChangesCommandOutput>;
/**
 * deserializeAws_json1_1SubmitContainerStateChangeCommand
 */
export declare const de_SubmitContainerStateChangeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SubmitContainerStateChangeCommandOutput>;
/**
 * deserializeAws_json1_1SubmitTaskStateChangeCommand
 */
export declare const de_SubmitTaskStateChangeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SubmitTaskStateChangeCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateCapacityProviderCommand
 */
export declare const de_UpdateCapacityProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateCapacityProviderCommandOutput>;
/**
 * deserializeAws_json1_1UpdateClusterCommand
 */
export declare const de_UpdateClusterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateClusterCommandOutput>;
/**
 * deserializeAws_json1_1UpdateClusterSettingsCommand
 */
export declare const de_UpdateClusterSettingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateClusterSettingsCommandOutput>;
/**
 * deserializeAws_json1_1UpdateContainerAgentCommand
 */
export declare const de_UpdateContainerAgentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateContainerAgentCommandOutput>;
/**
 * deserializeAws_json1_1UpdateContainerInstancesStateCommand
 */
export declare const de_UpdateContainerInstancesStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateContainerInstancesStateCommandOutput>;
/**
 * deserializeAws_json1_1UpdateServiceCommand
 */
export declare const de_UpdateServiceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateServiceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateServicePrimaryTaskSetCommand
 */
export declare const de_UpdateServicePrimaryTaskSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateServicePrimaryTaskSetCommandOutput>;
/**
 * deserializeAws_json1_1UpdateTaskProtectionCommand
 */
export declare const de_UpdateTaskProtectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateTaskProtectionCommandOutput>;
/**
 * deserializeAws_json1_1UpdateTaskSetCommand
 */
export declare const de_UpdateTaskSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateTaskSetCommandOutput>;
