import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetPlatformApplicationAttributesCommand, se_GetPlatformApplicationAttributesCommand, } from "../protocols/Aws_query";
export { $Command };
export class GetPlatformApplicationAttributesCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonSimpleNotificationService", "GetPlatformApplicationAttributes", {})
    .n("SNSClient", "GetPlatformApplicationAttributesCommand")
    .f(void 0, void 0)
    .ser(se_GetPlatformApplicationAttributesCommand)
    .de(de_GetPlatformApplicationAttributesCommand)
    .build() {
}
